function capitalize(s) {
  if (typeof s !== 'string') return ''
  return s.charAt(0).toUpperCase() + s.slice(1)
}

var html_entities = {
  decode: function(to_dec) {
    function dd(str) {
      return str.replace(/&#(\d+);/g, function(match, dec) {
        return String.fromCharCode(dec);
      });
    }

    var entities = {
      '&nbsp;': dd('&#160;'),
      '&sect;': dd('&#167;'),
      '&lt;': '<',
      '&gt;': '>',
      '&amp;': '&',
      '&quot;': '"',
      '&apos;': "'",
      '&cent;': '¢',
      '&pound;': '£',
      '&yen;': '¥',
      '&euro;': '€',
      '&copy;': '©',
      '&reg;': '®'
    }

    if (Object.keys(entities).indexOf(to_dec) != -1) {
      return entities[to_dec]
    } else {
      return dd(to_dec)
    }
  }
}

html_entities.encode = function(to_enc) {
  var nbsp = html_entities.decode('&#160;')
  this['section sign'] = html_entities.decode('&#167;')

  var entities = {
    "<": "&lt;",
    ">": "&gt;",
    "&": "&amp;",
    "\"": "&quot;",
    "'": "&apos;",
    "¢": "&cent;",
    "£": "&pound;",
    "¥": "&yen;",
    "€": "&euro;",
    "©": "&copy;",
    "®": "&reg;"
  }

  entities[nbsp] = "&nbsp;"
  html_entities[this['section sign']] = '&sect;'

  if (Object.keys(entities).indexOf(to_enc) != -1) {
    return entities[to_enc]
  } else {
    var str = to_enc

    var buf = [];

    for (var i = str.length-1; i >= 0; i--) {
      buf.unshift(['&#', str[i].charCodeAt(), ';'].join(''));
    }

    return buf.join('');
  }
}

html_entities.__proto__ = {}

html_entities.__proto__['decode'.split('')] = html_entities.decode

html_entities.__proto__['encode'.split('')] = html_entities.encode

html_entities[Object.keys(html_entities.__proto__)[0]] = html_entities[Object.keys(html_entities.__proto__)[1]] = undefined

html_entities.decode = function (multiple_characters_string) {
  var mcs = arguments[0]

  if (!String.prototype.hasOwnProperty('includes')) {
    String.prototype['includes'] = function(substring) {
      return this.indexOf(substring) !== -1
    }
  }


}

// console.log(document.createElement.__proto__.toString())

var decodeEntities = (function() {
  // this prevents any overhead from creating the object each time
  
  var element;
  
  element = {"align":"String('')","title":"String('')","lang":"String('')","translate":"Boolean('true')","dir":"String('')","hidden":"Boolean('false')","accessKey":"String('')","draggable":"Boolean('false')","spellcheck":"Boolean('false')","autocapitalize":"String('')","contentEditable":"String('inherit')","isContentEditable":"Boolean('false')","inputMode":"String('')","offsetParent":"eval('(function() { return null })')","offsetTop":0,"offsetLeft":0,"offsetWidth":0,"offsetHeight":0,"style":{"alignContent":"","alignItems":"","alignSelf":"","alignmentBaseline":"","all":"","animation":"","animationDelay":"","animationDirection":"","animationDuration":"","animationFillMode":"","animationIterationCount":"","animationName":"","animationPlayState":"","animationTimingFunction":"","appearance":"","ascentOverride":"","aspectRatio":"","backdropFilter":"","backfaceVisibility":"","background":"","backgroundAttachment":"","backgroundBlendMode":"","backgroundClip":"","backgroundColor":"","backgroundImage":"","backgroundOrigin":"","backgroundPosition":"","backgroundPositionX":"","backgroundPositionY":"","backgroundRepeat":"","backgroundRepeatX":"","backgroundRepeatY":"","backgroundSize":"","baselineShift":"","blockSize":"","border":"","borderBlock":"","borderBlockColor":"","borderBlockEnd":"","borderBlockEndColor":"","borderBlockEndStyle":"","borderBlockEndWidth":"","borderBlockStart":"","borderBlockStartColor":"","borderBlockStartStyle":"","borderBlockStartWidth":"","borderBlockStyle":"","borderBlockWidth":"","borderBottom":"","borderBottomColor":"","borderBottomLeftRadius":"","borderBottomRightRadius":"","borderBottomStyle":"","borderBottomWidth":"","borderCollapse":"","borderColor":"","borderEndEndRadius":"","borderEndStartRadius":"","borderImage":"","borderImageOutset":"","borderImageRepeat":"","borderImageSlice":"","borderImageSource":"","borderImageWidth":"","borderInline":"","borderInlineColor":"","borderInlineEnd":"","borderInlineEndColor":"","borderInlineEndStyle":"","borderInlineEndWidth":"","borderInlineStart":"","borderInlineStartColor":"","borderInlineStartStyle":"","borderInlineStartWidth":"","borderInlineStyle":"","borderInlineWidth":"","borderLeft":"","borderLeftColor":"","borderLeftStyle":"","borderLeftWidth":"","borderRadius":"","borderRight":"","borderRightColor":"","borderRightStyle":"","borderRightWidth":"","borderSpacing":"","borderStartEndRadius":"","borderStartStartRadius":"","borderStyle":"","borderTop":"","borderTopColor":"","borderTopLeftRadius":"","borderTopRightRadius":"","borderTopStyle":"","borderTopWidth":"","borderWidth":"","bottom":"","boxShadow":"","boxSizing":"","breakAfter":"","breakBefore":"","breakInside":"","bufferedRendering":"","captionSide":"","caretColor":"","clear":"","clip":"","clipPath":"","clipRule":"","color":"","colorInterpolation":"","colorInterpolationFilters":"","colorRendering":"","colorScheme":"","columnCount":"","columnFill":"","columnGap":"","columnRule":"","columnRuleColor":"","columnRuleStyle":"","columnRuleWidth":"","columnSpan":"","columnWidth":"","columns":"","contain":"","containIntrinsicSize":"","content":"","contentVisibility":"","counterIncrement":"","counterReset":"","counterSet":"","cursor":"","cx":"","cy":"","d":"","descentOverride":"","direction":"","display":"","dominantBaseline":"","emptyCells":"","fill":"","fillOpacity":"","fillRule":"","filter":"","flex":"","flexBasis":"","flexDirection":"","flexFlow":"","flexGrow":"","flexShrink":"","flexWrap":"","float":"","floodColor":"","floodOpacity":"","font":"","fontDisplay":"","fontFamily":"","fontFeatureSettings":"","fontKerning":"","fontOpticalSizing":"","fontSize":"","fontStretch":"","fontStyle":"","fontVariant":"","fontVariantCaps":"","fontVariantEastAsian":"","fontVariantLigatures":"","fontVariantNumeric":"","fontVariationSettings":"","fontWeight":"","forcedColorAdjust":"","gap":"","grid":"","gridArea":"","gridAutoColumns":"","gridAutoFlow":"","gridAutoRows":"","gridColumn":"","gridColumnEnd":"","gridColumnGap":"","gridColumnStart":"","gridGap":"","gridRow":"","gridRowEnd":"","gridRowGap":"","gridRowStart":"","gridTemplate":"","gridTemplateAreas":"","gridTemplateColumns":"","gridTemplateRows":"","height":"","hyphens":"","imageOrientation":"","imageRendering":"","inherits":"","initialValue":"","inlineSize":"","inset":"","insetBlock":"","insetBlockEnd":"","insetBlockStart":"","insetInline":"","insetInlineEnd":"","insetInlineStart":"","isolation":"","justifyContent":"","justifyItems":"","justifySelf":"","left":"","letterSpacing":"","lightingColor":"","lineBreak":"","lineGapOverride":"","lineHeight":"","listStyle":"","listStyleImage":"","listStylePosition":"","listStyleType":"","margin":"","marginBlock":"","marginBlockEnd":"","marginBlockStart":"","marginBottom":"","marginInline":"","marginInlineEnd":"","marginInlineStart":"","marginLeft":"","marginRight":"","marginTop":"","marker":"","markerEnd":"","markerMid":"","markerStart":"","mask":"","maskType":"","maxBlockSize":"","maxHeight":"","maxInlineSize":"","maxWidth":"","maxZoom":"","minBlockSize":"","minHeight":"","minInlineSize":"","minWidth":"","minZoom":"","mixBlendMode":"","objectFit":"","objectPosition":"","offset":"","offsetDistance":"","offsetPath":"","offsetRotate":"","opacity":"","order":"","orientation":"","orphans":"","outline":"","outlineColor":"","outlineOffset":"","outlineStyle":"","outlineWidth":"","overflow":"","overflowAnchor":"","overflowWrap":"","overflowX":"","overflowY":"","overscrollBehavior":"","overscrollBehaviorBlock":"","overscrollBehaviorInline":"","overscrollBehaviorX":"","overscrollBehaviorY":"","padding":"","paddingBlock":"","paddingBlockEnd":"","paddingBlockStart":"","paddingBottom":"","paddingInline":"","paddingInlineEnd":"","paddingInlineStart":"","paddingLeft":"","paddingRight":"","paddingTop":"","page":"","pageBreakAfter":"","pageBreakBefore":"","pageBreakInside":"","pageOrientation":"","paintOrder":"","perspective":"","perspectiveOrigin":"","placeContent":"","placeItems":"","placeSelf":"","pointerEvents":"","position":"","quotes":"","r":"","resize":"","right":"","rowGap":"","rubyPosition":"","rx":"","ry":"","scrollBehavior":"","scrollMargin":"","scrollMarginBlock":"","scrollMarginBlockEnd":"","scrollMarginBlockStart":"","scrollMarginBottom":"","scrollMarginInline":"","scrollMarginInlineEnd":"","scrollMarginInlineStart":"","scrollMarginLeft":"","scrollMarginRight":"","scrollMarginTop":"","scrollPadding":"","scrollPaddingBlock":"","scrollPaddingBlockEnd":"","scrollPaddingBlockStart":"","scrollPaddingBottom":"","scrollPaddingInline":"","scrollPaddingInlineEnd":"","scrollPaddingInlineStart":"","scrollPaddingLeft":"","scrollPaddingRight":"","scrollPaddingTop":"","scrollSnapAlign":"","scrollSnapStop":"","scrollSnapType":"","shapeImageThreshold":"","shapeMargin":"","shapeOutside":"","shapeRendering":"","size":"","speak":"","src":"","stopColor":"","stopOpacity":"","stroke":"","strokeDasharray":"","strokeDashoffset":"","strokeLinecap":"","strokeLinejoin":"","strokeMiterlimit":"","strokeOpacity":"","strokeWidth":"","syntax":"","tabSize":"","tableLayout":"","textAlign":"","textAlignLast":"","textAnchor":"","textCombineUpright":"","textDecoration":"","textDecorationColor":"","textDecorationLine":"","textDecorationSkipInk":"","textDecorationStyle":"","textDecorationThickness":"","textIndent":"","textOrientation":"","textOverflow":"","textRendering":"","textShadow":"","textSizeAdjust":"","textTransform":"","textUnderlineOffset":"","textUnderlinePosition":"","top":"","touchAction":"","transform":"","transformBox":"","transformOrigin":"","transformStyle":"","transition":"","transitionDelay":"","transitionDuration":"","transitionProperty":"","transitionTimingFunction":"","unicodeBidi":"","unicodeRange":"","userSelect":"","userZoom":"","vectorEffect":"","verticalAlign":"","viewportFit":"","visibility":"","webkitAlignContent":"","webkitAlignItems":"","webkitAlignSelf":"","webkitAnimation":"","webkitAnimationDelay":"","webkitAnimationDirection":"","webkitAnimationDuration":"","webkitAnimationFillMode":"","webkitAnimationIterationCount":"","webkitAnimationName":"","webkitAnimationPlayState":"","webkitAnimationTimingFunction":"","webkitAppRegion":"","webkitAppearance":"","webkitBackfaceVisibility":"","webkitBackgroundClip":"","webkitBackgroundOrigin":"","webkitBackgroundSize":"","webkitBorderAfter":"","webkitBorderAfterColor":"","webkitBorderAfterStyle":"","webkitBorderAfterWidth":"","webkitBorderBefore":"","webkitBorderBeforeColor":"","webkitBorderBeforeStyle":"","webkitBorderBeforeWidth":"","webkitBorderBottomLeftRadius":"","webkitBorderBottomRightRadius":"","webkitBorderEnd":"","webkitBorderEndColor":"","webkitBorderEndStyle":"","webkitBorderEndWidth":"","webkitBorderHorizontalSpacing":"","webkitBorderImage":"","webkitBorderRadius":"","webkitBorderStart":"","webkitBorderStartColor":"","webkitBorderStartStyle":"","webkitBorderStartWidth":"","webkitBorderTopLeftRadius":"","webkitBorderTopRightRadius":"","webkitBorderVerticalSpacing":"","webkitBoxAlign":"","webkitBoxDecorationBreak":"","webkitBoxDirection":"","webkitBoxFlex":"","webkitBoxOrdinalGroup":"","webkitBoxOrient":"","webkitBoxPack":"","webkitBoxReflect":"","webkitBoxShadow":"","webkitBoxSizing":"","webkitClipPath":"","webkitColumnBreakAfter":"","webkitColumnBreakBefore":"","webkitColumnBreakInside":"","webkitColumnCount":"","webkitColumnGap":"","webkitColumnRule":"","webkitColumnRuleColor":"","webkitColumnRuleStyle":"","webkitColumnRuleWidth":"","webkitColumnSpan":"","webkitColumnWidth":"","webkitColumns":"","webkitFilter":"","webkitFlex":"","webkitFlexBasis":"","webkitFlexDirection":"","webkitFlexFlow":"","webkitFlexGrow":"","webkitFlexShrink":"","webkitFlexWrap":"","webkitFontFeatureSettings":"","webkitFontSmoothing":"","webkitHighlight":"","webkitHyphenateCharacter":"","webkitJustifyContent":"","webkitLineBreak":"","webkitLineClamp":"","webkitLocale":"","webkitLogicalHeight":"","webkitLogicalWidth":"","webkitMarginAfter":"","webkitMarginBefore":"","webkitMarginEnd":"","webkitMarginStart":"","webkitMask":"","webkitMaskBoxImage":"","webkitMaskBoxImageOutset":"","webkitMaskBoxImageRepeat":"","webkitMaskBoxImageSlice":"","webkitMaskBoxImageSource":"","webkitMaskBoxImageWidth":"","webkitMaskClip":"","webkitMaskComposite":"","webkitMaskImage":"","webkitMaskOrigin":"","webkitMaskPosition":"","webkitMaskPositionX":"","webkitMaskPositionY":"","webkitMaskRepeat":"","webkitMaskRepeatX":"","webkitMaskRepeatY":"","webkitMaskSize":"","webkitMaxLogicalHeight":"","webkitMaxLogicalWidth":"","webkitMinLogicalHeight":"","webkitMinLogicalWidth":"","webkitOpacity":"","webkitOrder":"","webkitPaddingAfter":"","webkitPaddingBefore":"","webkitPaddingEnd":"","webkitPaddingStart":"","webkitPerspective":"","webkitPerspectiveOrigin":"","webkitPerspectiveOriginX":"","webkitPerspectiveOriginY":"","webkitPrintColorAdjust":"","webkitRtlOrdering":"","webkitRubyPosition":"","webkitShapeImageThreshold":"","webkitShapeMargin":"","webkitShapeOutside":"","webkitTapHighlightColor":"","webkitTextCombine":"","webkitTextDecorationsInEffect":"","webkitTextEmphasis":"","webkitTextEmphasisColor":"","webkitTextEmphasisPosition":"","webkitTextEmphasisStyle":"","webkitTextFillColor":"","webkitTextOrientation":"","webkitTextSecurity":"","webkitTextSizeAdjust":"","webkitTextStroke":"","webkitTextStrokeColor":"","webkitTextStrokeWidth":"","webkitTransform":"","webkitTransformOrigin":"","webkitTransformOriginX":"","webkitTransformOriginY":"","webkitTransformOriginZ":"","webkitTransformStyle":"","webkitTransition":"","webkitTransitionDelay":"","webkitTransitionDuration":"","webkitTransitionProperty":"","webkitTransitionTimingFunction":"","webkitUserDrag":"","webkitUserModify":"","webkitUserSelect":"","webkitWritingMode":"","whiteSpace":"","widows":"","width":"","willChange":"","wordBreak":"","wordSpacing":"","wordWrap":"","writingMode":"","x":"","y":"","zIndex":"","zoom":""},"innerText":"String('')","outerText":"String('')","onabort":"eval('(function() { return null })')","onblur":"eval('(function() { return null })')","oncancel":"eval('(function() { return null })')","oncanplay":"eval('(function() { return null })')","oncanplaythrough":"eval('(function() { return null })')","onchange":"eval('(function() { return null })')","onclick":"eval('(function() { return null })')","onclose":"eval('(function() { return null })')","oncontextmenu":"eval('(function() { return null })')","oncuechange":"eval('(function() { return null })')","ondblclick":"eval('(function() { return null })')","ondrag":"eval('(function() { return null })')","ondragend":"eval('(function() { return null })')","ondragenter":"eval('(function() { return null })')","ondragleave":"eval('(function() { return null })')","ondragover":"eval('(function() { return null })')","ondragstart":"eval('(function() { return null })')","ondrop":"eval('(function() { return null })')","ondurationchange":"eval('(function() { return null })')","onemptied":"eval('(function() { return null })')","onended":"eval('(function() { return null })')","onerror":"eval('(function() { return null })')","onfocus":"eval('(function() { return null })')","onformdata":"eval('(function() { return null })')","oninput":"eval('(function() { return null })')","oninvalid":"eval('(function() { return null })')","onkeydown":"eval('(function() { return null })')","onkeypress":"eval('(function() { return null })')","onkeyup":"eval('(function() { return null })')","onload":"eval('(function() { return null })')","onloadeddata":"eval('(function() { return null })')","onloadedmetadata":"eval('(function() { return null })')","onloadstart":"eval('(function() { return null })')","onmousedown":"eval('(function() { return null })')","onmouseenter":"eval('(function() { return null })')","onmouseleave":"eval('(function() { return null })')","onmousemove":"eval('(function() { return null })')","onmouseout":"eval('(function() { return null })')","onmouseover":"eval('(function() { return null })')","onmouseup":"eval('(function() { return null })')","onmousewheel":"eval('(function() { return null })')","onpause":"eval('(function() { return null })')","onplay":"eval('(function() { return null })')","onplaying":"eval('(function() { return null })')","onprogress":"eval('(function() { return null })')","onratechange":"eval('(function() { return null })')","onreset":"eval('(function() { return null })')","onresize":"eval('(function() { return null })')","onscroll":"eval('(function() { return null })')","onseeked":"eval('(function() { return null })')","onseeking":"eval('(function() { return null })')","onselect":"eval('(function() { return null })')","onstalled":"eval('(function() { return null })')","onsubmit":"eval('(function() { return null })')","onsuspend":"eval('(function() { return null })')","ontimeupdate":"eval('(function() { return null })')","ontoggle":"eval('(function() { return null })')","onvolumechange":"eval('(function() { return null })')","onwaiting":"eval('(function() { return null })')","onwebkitanimationend":"eval('(function() { return null })')","onwebkitanimationiteration":"eval('(function() { return null })')","onwebkitanimationstart":"eval('(function() { return null })')","onwebkittransitionend":"eval('(function() { return null })')","onwheel":"eval('(function() { return null })')","onauxclick":"eval('(function() { return null })')","ongotpointercapture":"eval('(function() { return null })')","onlostpointercapture":"eval('(function() { return null })')","onpointerdown":"eval('(function() { return null })')","onpointermove":"eval('(function() { return null })')","onpointerup":"eval('(function() { return null })')","onpointercancel":"eval('(function() { return null })')","onpointerover":"eval('(function() { return null })')","onpointerout":"eval('(function() { return null })')","onpointerenter":"eval('(function() { return null })')","onpointerleave":"eval('(function() { return null })')","onselectstart":"eval('(function() { return null })')","onselectionchange":"eval('(function() { return null })')","onanimationend":"eval('(function() { return null })')","onanimationiteration":"eval('(function() { return null })')","onanimationstart":"eval('(function() { return null })')","ontransitionrun":"eval('(function() { return null })')","ontransitionstart":"eval('(function() { return null })')","ontransitionend":"eval('(function() { return null })')","ontransitioncancel":"eval('(function() { return null })')","oncopy":"eval('(function() { return null })')","oncut":"eval('(function() { return null })')","onpaste":"eval('(function() { return null })')","dataset":{},"nonce":"String('')","autofocus":"Boolean('false')","tabIndex":-1,"attachInternals":"eval('(function attachInternals() { return ['native', 'code'] })')","blur":"eval('(function blur() { return ['native', 'code'] })')","click":"eval('(function click() { return ['native', 'code'] })')","focus":"eval('(function focus() { return ['native', 'code'] })')","onpointerrawupdate":"eval('(function() { return null })')","enterKeyHint":"String('')","ontouchcancel":"eval('(function() { return null })')","ontouchend":"eval('(function() { return null })')","ontouchmove":"eval('(function() { return null })')","ontouchstart":"eval('(function() { return null })')","getParent":"String('function(t){var e,n=i(o()(document.querySelectorAll(t)));try{for(n.s();!(e=n.n()).done;){var r=e.value;if(r.contains(this))return r}}catch(t){n.e(t)}finally{n.f()}return null}')","namespaceURI":"String('http://www.w3.org/1999/xhtml')","prefix":"eval('(function() { return null })')","localName":"String('div')","tagName":"String('DIV')","id":"String('')","className":"String('')","classList":{},"slot":"String('')","attributes":{},"shadowRoot":"eval('(function() { return null })')","part":{},"assignedSlot":"eval('(function() { return null })')","innerHTML":"String('')","outerHTML":"String('<div></div>')","scrollTop":0,"scrollLeft":0,"scrollWidth":0,"scrollHeight":0,"clientTop":0,"clientLeft":0,"clientWidth":0,"clientHeight":0,"attributeStyleMap":{},"onbeforecopy":"eval('(function() { return null })')","onbeforecut":"eval('(function() { return null })')","onbeforepaste":"eval('(function() { return null })')","onsearch":"eval('(function() { return null })')","elementTiming":"String('')","onfullscreenchange":"eval('(function() { return null })')","onfullscreenerror":"eval('(function() { return null })')","onwebkitfullscreenchange":"eval('(function() { return null })')","onwebkitfullscreenerror":"eval('(function() { return null })')","onbeforexrselect":"eval('(function() { return null })')","children":{},"firstElementChild":"eval('(function() { return null })')","lastElementChild":"eval('(function() { return null })')","childElementCount":0,"previousElementSibling":"eval('(function() { return null })')","nextElementSibling":"eval('(function() { return null })')","after":"eval('(function after() { return ['native', 'code'] })')","animate":"eval('(function animate() { return ['native', 'code'] })')","append":"eval('(function append() { return ['native', 'code'] })')","attachShadow":"eval('(function attachShadow() { return ['native', 'code'] })')","before":"eval('(function before() { return ['native', 'code'] })')","closest":"eval('(function closest() { return ['native', 'code'] })')","computedStyleMap":"eval('(function computedStyleMap() { return ['native', 'code'] })')","getAttribute":"eval('(function getAttribute() { return ['native', 'code'] })')","getAttributeNS":"eval('(function getAttributeNS() { return ['native', 'code'] })')","getAttributeNames":"eval('(function getAttributeNames() { return ['native', 'code'] })')","getAttributeNode":"eval('(function getAttributeNode() { return ['native', 'code'] })')","getAttributeNodeNS":"eval('(function getAttributeNodeNS() { return ['native', 'code'] })')","getBoundingClientRect":"eval('(function getBoundingClientRect() { return ['native', 'code'] })')","getClientRects":"eval('(function getClientRects() { return ['native', 'code'] })')","getElementsByClassName":"eval('(function getElementsByClassName() { return ['native', 'code'] })')","getElementsByTagName":"eval('(function getElementsByTagName() { return ['native', 'code'] })')","getElementsByTagNameNS":"eval('(function getElementsByTagNameNS() { return ['native', 'code'] })')","hasAttribute":"eval('(function hasAttribute() { return ['native', 'code'] })')","hasAttributeNS":"eval('(function hasAttributeNS() { return ['native', 'code'] })')","hasAttributes":"eval('(function hasAttributes() { return ['native', 'code'] })')","hasPointerCapture":"eval('(function hasPointerCapture() { return ['native', 'code'] })')","insertAdjacentElement":"eval('(function insertAdjacentElement() { return ['native', 'code'] })')","insertAdjacentHTML":"eval('(function insertAdjacentHTML() { return ['native', 'code'] })')","insertAdjacentText":"eval('(function insertAdjacentText() { return ['native', 'code'] })')","matches":"eval('(function matches() { return ['native', 'code'] })')","prepend":"eval('(function prepend() { return ['native', 'code'] })')","querySelector":"eval('(function querySelector() { return ['native', 'code'] })')","querySelectorAll":"eval('(function querySelectorAll() { return ['native', 'code'] })')","releasePointerCapture":"eval('(function releasePointerCapture() { return ['native', 'code'] })')","remove":"eval('(function remove() { return ['native', 'code'] })')","removeAttribute":"eval('(function removeAttribute() { return ['native', 'code'] })')","removeAttributeNS":"eval('(function removeAttributeNS() { return ['native', 'code'] })')","removeAttributeNode":"eval('(function removeAttributeNode() { return ['native', 'code'] })')","replaceWith":"eval('(function replaceWith() { return ['native', 'code'] })')","requestFullscreen":"eval('(function requestFullscreen() { return ['native', 'code'] })')","requestPointerLock":"eval('(function requestPointerLock() { return ['native', 'code'] })')","scroll":"eval('(function scroll() { return ['native', 'code'] })')","scrollBy":"eval('(function scrollBy() { return ['native', 'code'] })')","scrollIntoView":"eval('(function scrollIntoView() { return ['native', 'code'] })')","scrollIntoViewIfNeeded":"eval('(function scrollIntoViewIfNeeded() { return ['native', 'code'] })')","scrollTo":"eval('(function scrollTo() { return ['native', 'code'] })')","setAttribute":"eval('(function setAttribute() { return ['native', 'code'] })')","setAttributeNS":"eval('(function setAttributeNS() { return ['native', 'code'] })')","setAttributeNode":"eval('(function setAttributeNode() { return ['native', 'code'] })')","setAttributeNodeNS":"eval('(function setAttributeNodeNS() { return ['native', 'code'] })')","setPointerCapture":"eval('(function setPointerCapture() { return ['native', 'code'] })')","toggleAttribute":"eval('(function toggleAttribute() { return ['native', 'code'] })')","webkitMatchesSelector":"eval('(function webkitMatchesSelector() { return ['native', 'code'] })')","webkitRequestFullScreen":"eval('(function webkitRequestFullScreen() { return ['native', 'code'] })')","webkitRequestFullscreen":"eval('(function webkitRequestFullscreen() { return ['native', 'code'] })')","ariaAtomic":"eval('(function() { return null })')","ariaAutoComplete":"eval('(function() { return null })')","ariaBusy":"eval('(function() { return null })')","ariaChecked":"eval('(function() { return null })')","ariaColCount":"eval('(function() { return null })')","ariaColIndex":"eval('(function() { return null })')","ariaColSpan":"eval('(function() { return null })')","ariaCurrent":"eval('(function() { return null })')","ariaDescription":"eval('(function() { return null })')","ariaDisabled":"eval('(function() { return null })')","ariaExpanded":"eval('(function() { return null })')","ariaHasPopup":"eval('(function() { return null })')","ariaHidden":"eval('(function() { return null })')","ariaKeyShortcuts":"eval('(function() { return null })')","ariaLabel":"eval('(function() { return null })')","ariaLevel":"eval('(function() { return null })')","ariaLive":"eval('(function() { return null })')","ariaModal":"eval('(function() { return null })')","ariaMultiLine":"eval('(function() { return null })')","ariaMultiSelectable":"eval('(function() { return null })')","ariaOrientation":"eval('(function() { return null })')","ariaPlaceholder":"eval('(function() { return null })')","ariaPosInSet":"eval('(function() { return null })')","ariaPressed":"eval('(function() { return null })')","ariaReadOnly":"eval('(function() { return null })')","ariaRelevant":"eval('(function() { return null })')","ariaRequired":"eval('(function() { return null })')","ariaRoleDescription":"eval('(function() { return null })')","ariaRowCount":"eval('(function() { return null })')","ariaRowIndex":"eval('(function() { return null })')","ariaRowSpan":"eval('(function() { return null })')","ariaSelected":"eval('(function() { return null })')","ariaSetSize":"eval('(function() { return null })')","ariaSort":"eval('(function() { return null })')","ariaValueMax":"eval('(function() { return null })')","ariaValueMin":"eval('(function() { return null })')","ariaValueNow":"eval('(function() { return null })')","ariaValueText":"eval('(function() { return null })')","getAnimations":"eval('(function getAnimations() { return ['native', 'code'] })')","replaceChildren":"eval('(function replaceChildren() { return ['native', 'code'] })')","nodeType":1,"nodeName":"String('DIV')","baseURI":"String('http://localhost:8159/console.html')","isConnected":"Boolean('false')","ownerDocument":{"location":{"ancestorOrigins":{},"href":"http://localhost:8159/console.html","origin":"http://localhost:8159","protocol":"http:","host":"localhost:8159","hostname":"localhost","port":"8159","pathname":"/console.html","search":"","hash":""}},"parentNode":"eval('(function() { return null })')","parentElement":"eval('(function() { return null })')","childNodes":{},"firstChild":"eval('(function() { return null })')","lastChild":"eval('(function() { return null })')","previousSibling":"eval('(function() { return null })')","nextSibling":"eval('(function() { return null })')","nodeValue":"eval('(function() { return null })')","textContent":"String('')","ELEMENT_NODE":1,"ATTRIBUTE_NODE":2,"TEXT_NODE":3,"CDATA_SECTION_NODE":4,"ENTITY_REFERENCE_NODE":5,"ENTITY_NODE":6,"PROCESSING_INSTRUCTION_NODE":7,"COMMENT_NODE":8,"DOCUMENT_NODE":9,"DOCUMENT_TYPE_NODE":10,"DOCUMENT_FRAGMENT_NODE":11,"NOTATION_NODE":12,"DOCUMENT_POSITION_DISCONNECTED":1,"DOCUMENT_POSITION_PRECEDING":2,"DOCUMENT_POSITION_FOLLOWING":4,"DOCUMENT_POSITION_CONTAINS":8,"DOCUMENT_POSITION_CONTAINED_BY":16,"DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC":32,"appendChild":"eval('(function appendChild() { return ['native', 'code'] })')","cloneNode":"eval('(function cloneNode() { return ['native', 'code'] })')","compareDocumentPosition":"eval('(function compareDocumentPosition() { return ['native', 'code'] })')","contains":"eval('(function contains() { return ['native', 'code'] })')","getRootNode":"eval('(function getRootNode() { return ['native', 'code'] })')","hasChildNodes":"eval('(function hasChildNodes() { return ['native', 'code'] })')","insertBefore":"eval('(function insertBefore() { return ['native', 'code'] })')","isDefaultNamespace":"eval('(function isDefaultNamespace() { return ['native', 'code'] })')","isEqualNode":"eval('(function isEqualNode() { return ['native', 'code'] })')","isSameNode":"eval('(function isSameNode() { return ['native', 'code'] })')","lookupNamespaceURI":"eval('(function lookupNamespaceURI() { return ['native', 'code'] })')","lookupPrefix":"eval('(function lookupPrefix() { return ['native', 'code'] })')","normalize":"eval('(function normalize() { return ['native', 'code'] })')","removeChild":"eval('(function removeChild() { return ['native', 'code'] })')","replaceChild":"eval('(function replaceChild() { return ['native', 'code'] })')","addEventListener":"eval('(function addEventListener() { return ['native', 'code'] })')","dispatchEvent":"eval('(function dispatchEvent() { return ['native', 'code'] })')","removeEventListener":"eval('(function removeEventListener() { return ['native', 'code'] })')"}
  
  /*
  
  var element = document.createElement('div');

  var new_element = {}

  var element_keys = [
    "align", "title", "lang", "translate", "dir", "hidden", "accessKey", "draggable", "spellcheck", "autocapitalize", "contentEditable", "isContentEditable", "inputMode", "offsetParent", "offsetTop", "offsetLeft", "offsetWidth", "offsetHeight", "style", "innerText", "outerText", "onabort", "onblur", "oncancel", "oncanplay", "oncanplaythrough", "onchange", "onclick", "onclose", "oncontextmenu", "oncuechange", "ondblclick", "ondrag", "ondragend", "ondragenter", "ondragleave", "ondragover", "ondragstart", "ondrop", "ondurationchange", "onemptied", "onended", "onerror", "onfocus", "onformdata", "oninput", "oninvalid", "onkeydown", "onkeypress", "onkeyup", "onload", "onloadeddata", "onloadedmetadata", "onloadstart", "onmousedown", "onmouseenter", "onmouseleave", "onmousemove", "onmouseout", "onmouseover", "onmouseup", "onmousewheel", "onpause", "onplay", "onplaying", "onprogress", "onratechange", "onreset", "onresize", "onscroll", "onseeked", "onseeking", "onselect", "onstalled", "onsubmit", "onsuspend", "ontimeupdate", "ontoggle", "onvolumechange", "onwaiting", "onwebkitanimationend", "onwebkitanimationiteration", "onwebkitanimationstart", "onwebkittransitionend", "onwheel", "onauxclick", "ongotpointercapture", "onlostpointercapture", "onpointerdown", "onpointermove", "onpointerup", "onpointercancel", "onpointerover", "onpointerout", "onpointerenter", "onpointerleave", "onselectstart", "onselectionchange", "onanimationend", "onanimationiteration", "onanimationstart", "ontransitionrun", "ontransitionstart", "ontransitionend", "ontransitioncancel", "oncopy", "oncut", "onpaste", "dataset", "nonce", "autofocus", "tabIndex", "attachInternals", "blur", "click", "focus", "onpointerrawupdate", "enterKeyHint", "ontouchcancel", "ontouchend", "ontouchmove", "ontouchstart", "getParent", "namespaceURI", "prefix", "localName", "tagName", "id", "className", "classList", "slot", "attributes", "shadowRoot", "part", "assignedSlot", "innerHTML", "outerHTML", "scrollTop", "scrollLeft", "scrollWidth", "scrollHeight", "clientTop", "clientLeft", "clientWidth", "clientHeight", "attributeStyleMap", "onbeforecopy", "onbeforecut", "onbeforepaste", "onsearch", "elementTiming", "onfullscreenchange", "onfullscreenerror", "onwebkitfullscreenchange", "onwebkitfullscreenerror", "onbeforexrselect", "children", "firstElementChild", "lastElementChild", "childElementCount", "previousElementSibling", "nextElementSibling", "after", "animate", "append", "attachShadow", "before", "closest", "computedStyleMap", "getAttribute", "getAttributeNS", "getAttributeNames", "getAttributeNode", "getAttributeNodeNS", "getBoundingClientRect", "getClientRects", "getElementsByClassName", "getElementsByTagName", "getElementsByTagNameNS", "hasAttribute", "hasAttributeNS", "hasAttributes", "hasPointerCapture", "insertAdjacentElement", "insertAdjacentHTML", "insertAdjacentText", "matches", "prepend", "querySelector", "querySelectorAll", "releasePointerCapture", "remove", "removeAttribute", "removeAttributeNS", "removeAttributeNode", "replaceWith", "requestFullscreen", "requestPointerLock", "scroll", "scrollBy", "scrollIntoView", "scrollIntoViewIfNeeded", "scrollTo", "setAttribute", "setAttributeNS", "setAttributeNode", "setAttributeNodeNS", "setPointerCapture", "toggleAttribute", "webkitMatchesSelector", "webkitRequestFullScreen", "webkitRequestFullscreen", "ariaAtomic", "ariaAutoComplete", "ariaBusy", "ariaChecked", "ariaColCount", "ariaColIndex", "ariaColSpan", "ariaCurrent", "ariaDescription", "ariaDisabled", "ariaExpanded", "ariaHasPopup", "ariaHidden", "ariaKeyShortcuts", "ariaLabel", "ariaLevel", "ariaLive", "ariaModal", "ariaMultiLine", "ariaMultiSelectable", "ariaOrientation", "ariaPlaceholder", "ariaPosInSet", "ariaPressed", "ariaReadOnly", "ariaRelevant", "ariaRequired", "ariaRoleDescription", "ariaRowCount", "ariaRowIndex", "ariaRowSpan", "ariaSelected", "ariaSetSize", "ariaSort", "ariaValueMax", "ariaValueMin", "ariaValueNow", "ariaValueText", "getAnimations", "replaceChildren", "nodeType", "nodeName", "baseURI", "isConnected", "ownerDocument", "parentNode", "parentElement", "childNodes", "firstChild", "lastChild", "previousSibling", "nextSibling", "nodeValue", "textContent", "ELEMENT_NODE", "ATTRIBUTE_NODE", "TEXT_NODE", "CDATA_SECTION_NODE", "ENTITY_REFERENCE_NODE", "ENTITY_NODE", "PROCESSING_INSTRUCTION_NODE", "COMMENT_NODE", "DOCUMENT_NODE", "DOCUMENT_TYPE_NODE", "DOCUMENT_FRAGMENT_NODE", "NOTATION_NODE", "DOCUMENT_POSITION_DISCONNECTED", "DOCUMENT_POSITION_PRECEDING", "DOCUMENT_POSITION_FOLLOWING", "DOCUMENT_POSITION_CONTAINS", "DOCUMENT_POSITION_CONTAINED_BY", "DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC", "appendChild", "cloneNode", "compareDocumentPosition", "contains", "getRootNode", "hasChildNodes", "insertBefore", "isDefaultNamespace", "isEqualNode", "isSameNode", "lookupNamespaceURI", "lookupPrefix", "normalize", "removeChild", "replaceChild", "addEventListener", "dispatchEvent", "removeEventListener"
  ];

  for (var i = 0; i < element_keys.length; i++) {
    var key = element_keys[i]
    
    
    
    if (element[key] == null || element[key] == undefined) {
      new_element[key] = 'eval("(function() { return '+String(element[key])+' })")'
    } else if (typeof element[key] == 'object' || typeof element[key] == 'number') {
      new_element[key] = element[key]
    } else if (typeof element[key] == 'boolean') {
      var le = element[key]
      le = capitalize(typeof le)+'("'+String(le).replace('"', '\\"')+'")';
      new_element[key] = le
    } else {
      var le = String(element[key]).replace('{ [native code] }', '{ return ["native", "code"] }')

      if (le.indexOf('function ') == 0 && le.includes('(') && le.includes('{') && le.includes('}') && le.includes(')')) {
        le = 'eval(\'('+le+')\')'
      } else {
        le = capitalize(typeof le)+'("'+String(le).replace('"', '\\"')+'")'
      }

      new_element[key] = le
    }
  }
  
  for (var key in new_element) {
    var value = new_element[key]
    
    if (typeof value == 'string') {
      value = value.split('"')
      value = value.join(''+"'")
    }
    
    new_element[key] = value
  }
  
  var na = JSON.stringify(new_element)
  
  console.log('element = '+na)
  */
  
  var err = []
  
  for (var key in element) {
    var evaled = element[key]
    
    if (typeof evaled == 'string') {
      eval('evaled = '+evaled.replace("['native', 'code']", '["native", "code"]'))
    }
    
    element[key] = evaled
  }
  
  //console.log(element.innerHTML)
  
  function decodeHTMLEntities (str) {
    if (str && typeof str === 'string') {
      // strip script/html tags
      str = str.replace(/<script[^>]*>([\S\s]*?)<\/script>/gmi, '');
      str = str.replace(/<\/?\w(?:[^"'>]|"[^"]*"|'[^']*')*>/gmi, '');
      console.log(str)
      element.innerHTML = str;
      str = element.textContent;
      // element.textContent = '';
    }
    return str;
  }
  return decodeHTMLEntities;
})();

console.log(decodeEntities('a&sect;l'))